<script setup>

import { ref, computed } from 'vue'
import { useProductsStore } from '../../stores/products.js'

import CatalogItem from './CatalogItem.vue'
import Filter from '../Filter.vue'
import { filterConfig } from '../../constants'

const productsStore = useProductsStore()
productsStore.getList()


const filter = ref('')
const category = ref('All')
const saleFilter = ref('All')
const priceFilter = ref('Sort by price')


function addItem(item) {
  productsStore.cart.push(item)
}

function onSelectCat(selCategory) {
  if (selCategory.value === 'type') {
    category.value = selCategory.name
  }
  if (selCategory.value === 'sale') {
    saleFilter.value = selCategory.name
  }
  if (selCategory.value === 'price') {
    priceFilter.value = selCategory.name
  }
}

const filteredProducts = computed(() => {
  return filterProductsByPrice(filterProductsByName(filterProductsByCategory(filterProductsBySale(productsStore.products))))
})

function filterProductsByCategory(products) {
  if (category.value === 'All') {
    return products
  } else {
    return products.filter(product => product.category === category.value)
  }
}

function filterProductsBySale(products) {
  if (saleFilter.value === 'All') {
    return products
  } else {
    return products.filter(product => product.sale === saleFilter.value)
  }
}

function filterProductsByName(products) {
  return products.filter(product => product.name.toLowerCase().includes(filter.value.toLowerCase()))
}

function filterProductsByPrice(products) {
  if (priceFilter.value === 'Sort by price') {
    return products
  }
  if (priceFilter.value === 'ASC') {
    return products.sort((a,b) => a.price - b.price)
  }
  if (priceFilter.value === 'DESC') {
    return products.sort((a,b) => b.price - a.price)
  }
}

</script>

<template>
  <div class="mt-12 flex justify-between">
    <div class="relative w-60 inline-block text-left">
      <label for="price" class="block text-sm font-medium text-gray-700">Search</label>
      <div class="relative mt-1 rounded-md shadow-sm">
        <input
          type="text"
          name="price"
          id="price"
          class="block w-full rounded-md border-gray-300 pl-7 pr-12 focus:border-black focus:ring-black sm:text-sm"
          v-model="filter"
        />
      </div>
    </div>

    <Filter
      v-for="(filterOpt, idx) in filterConfig"
      :key="idx"
      class="relative w-60 inline-block text-left"
      :options="filterOpt.config"
      :title="filterOpt.title"
      @select="onSelectCat"
    />

  </div>

  <h2 class="mt-6 text-2xl font-bold tracking-tight text-gray-900">Bestsellers</h2>

  <div class="mt-6 grid grid-cols-1 gap-y-10 gap-x-6 sm:grid-cols-2 lg:grid-cols-4 xl:gap-x-8">
    <CatalogItem
      v-for="product in filteredProducts"
      :key="product.id"
      :product="product"
      @add-item="addItem"
    />
  </div>
</template>
